#!/usr/bin/env sh

CURRENT_DIR=$(pwd)
SCRIPT_DIR=$(dirname "$0")
ABSOLUTE_PATH="$CURRENT_DIR/$SCRIPT_DIR"
TEMPLATE_PATH="$ABSOLUTE_PATH/../template/.cbctl.yaml.tmpl"
mkdir -p "$ABSOLUTE_PATH/../generated"
DEST_PATH="$ABSOLUTE_PATH/../generated/.cbctl.yaml"

replace_values() {
  if [ -z "$CB_API_ID" ]; then
    echo "CB_API_ID is empty"
    exit 1
  elif [ -z "$CB_API_KEY" ]; then
    echo "CB_API_KEY is empty"
    exit 1
  elif [ -z "$DEFAULT_BUILD_STEPS" ]; then
    echo "DEFAULT_BUILD_STEPS is empty"
    exit 1
  elif [ -z "$ORG_KEY" ]; then
    echo "ORG_KEY is empty"
    exit 1
  elif [ -z "$SAAS_URL" ]; then
    echo "SAAS_URL is empty"
    exit 1
  fi

  sed -e "s;_CB_API_ID_;${CB_API_ID};" \
  -e "s;_CB_API_KEY_;${CB_API_KEY};" \
  -e "s;_DEFAULT_BUILD_STEPS_;${DEFAULT_BUILD_STEPS};" \
  -e "s;_ORG_KEY_;${ORG_KEY};" \
  -e "s;_SAAS_URL_;${SAAS_URL};" \
  "$TEMPLATE_PATH" > "$DEST_PATH"
}

validate_template_file_path() {
  if [ -f "$1" ]; then
    echo "$1 Exists!"
    return
  else
    echo "Validation failed, the file $1 does not exist."
    exit 1
  fi
}

validate_template_file_path "$TEMPLATE_PATH"
replace_values
validate_template_file_path "$DEST_PATH"